<?php
namespace ACL\Helpers\Instances;

use ACL\Services\Operador;
use ACL\Services\OperadorLabelVersao;
use ACL\Services\Parcnegocio;
use ACL\Services\Perfilacesso;
use Exception;
use Zeedhi\Framework\DependencyInjection\InstanceManager;


class Service {

    /** @return  Service */
    public static function getInstance()
    {
        return new static();
    }

    /** @return Operador
     * @throws Exception
     */
    public function getOperador(): Operador
    {
        return InstanceManager::getInstance()->getService('ACL\Services\Operador');
    }

    /**
     * @return Parcnegocio
     * @throws Exception
     */
    public function getParcnegocio(): ParcNegocio
    {
        return InstanceManager::getInstance()->getService('ACL\Services\Parcnegocio');
    }

    /**
     * @return OperadorLabelVersao
     * @throws Exception
     */
    public function getOperadorLabelVersao(): OperadorLabelVersao
    {
        return InstanceManager::getInstance()->getService('ACL\Services\OperadorLabelVersao');
    }

    /**
     * @return Perfilacesso
     * @throws Exception
     */
    public function getPerfilacesso(): Perfilacesso
    {
        return InstanceManager::getInstance()->getService('ACL\Services\Perfilacesso');
    }
}
