<?php

namespace ACL\Services;

use ACL\Helpers\Instances\InstanceProvider;
use ACL\Repositories\Organizacao as OrganizacaoRepository;
use ACL\Util\ACLSession;
use Exception;

class Organizacao {

    /**
     * @var \Teknisa\Libs\Util\Environment
     */
    private $libEnvironment;

    /**
     * @var OrganizacaoRepository
     */
    private $organizacaoRepository;

    /**
     * Organizacao constructor.
     * @param OrganizacaoRepository $organizacaoRepository
     * @throws Exception
     */
    public function __construct(OrganizacaoRepository $organizacaoRepository)
    {
        $this->organizacaoRepository = $organizacaoRepository;
        $this->libEnvironment =  InstanceProvider::getLibEnvironment();
    }

    /**
     * @return array
     */
    public function findOrganizacao(): array
    {
        return $this->organizacaoRepository->findOrganizacao(getNrorg());
    }

    /**
     * @param $cdoperador
     * @param null $toRelate
     * @return array
     */
    public function findOrgOrgoper($cdoperador, $toRelate = null): array
    {
        if ($toRelate) {
            return $this->organizacaoRepository->findOrgOrgoperToRelate($cdoperador);
        }
        return $this->organizacaoRepository->findOrgOrgoper($cdoperador, getNrorg());
    }

    /**
     * @param $params
     * @throws Exception
     */
    public function createOrgOrgoper($params)
    {

        foreach ($params as $row) {
            $nrorganizacaooper = InstanceProvider::getNewCode()->getCodeByTableName('ORGANIZACAOOPER', getNrorg());
            InstanceProvider::getRepository()->getOrganizacaooper()->createOrganizacaooper(
                $nrorganizacaooper, $row['NRORG'], $row['CDOPERADOR'], getNrorg(), getCurrentUserId(), 'S'
            );
        }
    }

    /**
     * @param $params
     * @throws \Doctrine\DBAL\Driver\Exception
     * @throws Exception
     */
    public function deleteOrganizacaooper($params)
    {
        foreach ($params as $row) {
            InstanceProvider::getRepository()->getOrganizacaooper()->deleteOrganizacaooper(
                $row['NRORGREL'], $row['CDOPERADOR'], getNrorg()
            );
        }
    }
}
