/*
-- =====================================================================
-- CUSTOMAN - Custo do Manual Aprovado e Custo da Companhia (Manual da Apresntao)
-- =====================================================================
*/
CREATE OR REPLACE PROCEDURE CUSTOMAN(
P_CDSEQCUSMA IN OUT CUSTOSEMA.CDSEQCUSSE%TYPE, -- Deve ser passado para o parmetro '0000000000'.
P_IDTIPMAN   IN VARCHAR DEFAULT 'M', -- 'M' - Manual Aprovado; 'A' - Manual da Apresentao.
P_CDSEQITEM  IN OUT NUMBER,
P_IDINSERES  IN VARCHAR DEFAULT 'N', -- 'S' - Insere Servio;  'N' - No Insere Servio.
P_IDINSEREP  IN VARCHAR DEFAULT 'N', -- 'S' - Insere Produto;  'N' - No Insere Produto; 'P' - Insere Somente os Produtos Principais.
P_IDINSERER  IN VARCHAR DEFAULT 'N', -- 'S' - Insere Receita;  'N' - No Insere Receita; 'P' - Insere Somente as Receitas Principais.
P_CDFILIAL   IN FILIAL.CDFILIAL%TYPE,
P_CDCIA      IN COMPANHIA.CDCIA%TYPE,
P_CDMANCIA   IN VARCHAR DEFAULT NULL, -- Lista ou Todos (Somente para Manual da Apresentao)
P_CDSECLACIC IN VARCHAR DEFAULT NULL, -- Lista ou Todos (Somente para Manual Aprovado)
P_DTCUSTO    IN DATE,
P_CDOPERADOR IN OPERADOR.CDOPERADOR%TYPE,

VRCUSULCLIQMAN OUT NUMBER,
VRCUSULCBRUMAN OUT NUMBER,
VRCUSMEDLIQMAN OUT NUMBER,
VRCUSMEDBRUMAN OUT NUMBER
) AS
V_CDMANCIA   SERVMANUAL.CDMANCIA%TYPE;
V_CDSERVICO  SERVMANUAL.CDSERVICO%TYPE;
/*V_CDCLASSE   SERVMANUAL.CDCLASSE%TYPE;
V_CDCICLO    SERVMANUAL.CDCICLO%TYPE;*/

V_CUSULCLIQSER NUMBER;
V_CUSULCBRUSER NUMBER;
V_CUSMEDLIQSER NUMBER;
V_CUSMEDBRUSER NUMBER;

V_CUSULCLIQMANT NUMBER;
V_CUSULCBRUMANT NUMBER;
V_CUSMEDLIQMANT NUMBER;
V_CUSMEDBRUMANT NUMBER;

/* Servio do Manual de Custos Aprovados */
/*CURSOR C_SERV IS
SELECT CDMANCIA,CDSERVICO--,CDCLASSE,CDCICLO
FROM SERVMANUAL
WHERE (CDFILIAL = P_CDFILIAL) AND
      (CDCIA    = P_CDCIA   ) AND
      (CDMANCIA = P_CDMANCIA) AND
      --(INSTR(NVL(P_CDSECLACIC,
      -- CDSERVICO||CDCLASSE||CDCICLO),
      -- CDSERVICO||CDCLASSE||CDCICLO)>0);
      (INSTR(NVL(P_CDSECLACIC,CDSERVICO),CDSERVICO)>0);*/
CURSOR C_SERV IS
SELECT EP.CDMANCIA,EP.CDPRODUTO AS CDSERVICO
FROM ESPEPROD EP, PRODUTO PR
WHERE (EP.CDFILIAL     = P_CDFILIAL  ) AND
      (EP.CDCIA        = P_CDCIA     ) AND
      (EP.CDMANCIA     = P_CDMANCIA  ) AND
      (INSTR(NVL(P_CDSECLACIC,EP.CDPRODUTO),EP.CDPRODUTO)>0) AND
      (EP.IDTPMANUAL   = 'M'         ) AND
      (PR.CDPRODUTO    = EP.CDPRODUTO) AND
      (PR.IDPRODCOMISS = '1'         );

/* Manual da Apresentao */
CURSOR C_MANAP IS
SELECT CDMANAP,NULL/*,NULL,NULL*/
FROM MANUALCIAAP
WHERE (CDFILIAL = P_CDFILIAL) AND
      (CDCIA    = P_CDCIA   ) AND
      (CDMANAP  = P_CDMANCIA);

BEGIN
   V_CUSULCLIQMANT := 0;
   V_CUSULCBRUMANT := 0;
   V_CUSMEDLIQMANT := 0;
   V_CUSMEDBRUMANT := 0;

   IF P_IDTIPMAN = 'M' THEN
      OPEN C_SERV;
   ELSIF P_IDTIPMAN = 'A' THEN
      OPEN C_MANAP;
   END IF;
   LOOP
      IF P_IDTIPMAN = 'M' THEN
         FETCH C_SERV
         INTO V_CDMANCIA,V_CDSERVICO/*,V_CDCLASSE,V_CDCICLO*/;
         EXIT WHEN C_SERV%NOTFOUND;
      	--VERIFICA_ESPEPROD(P_CDFILIAL,P_CDCIA,V_CDMANCIA,'M','P',V_CDSERVICO); /* Verifica a especificao para servios do manual */
      ELSIF P_IDTIPMAN = 'A' THEN
         FETCH C_MANAP
         INTO V_CDMANCIA,V_CDSERVICO/*,V_CDCLASSE,V_CDCICLO*/;
         EXIT WHEN C_MANAP%NOTFOUND;
      END IF;

      CUSTOSERV(P_CDSEQCUSMA,P_IDTIPMAN,P_CDSEQITEM,P_IDINSERES,
                P_IDINSEREP,P_IDINSERER,P_CDFILIAL,P_CDCIA,
                V_CDMANCIA,V_CDSERVICO,/*V_CDCLASSE,V_CDCICLO,*/NULL,
                P_DTCUSTO,P_CDOPERADOR,V_CUSULCLIQSER,V_CUSULCBRUSER,
                V_CUSMEDLIQSER,V_CUSMEDBRUSER);

      V_CUSULCLIQMANT := V_CUSULCLIQMANT + V_CUSULCLIQSER;
      V_CUSULCBRUMANT := V_CUSULCBRUMANT + V_CUSULCBRUSER;
      V_CUSMEDLIQMANT := V_CUSMEDLIQMANT + V_CUSMEDLIQSER;
      V_CUSMEDBRUMANT := V_CUSMEDBRUMANT + V_CUSMEDBRUSER;
   END LOOP;

   VRCUSULCLIQMAN := V_CUSULCLIQMANT;
   VRCUSULCBRUMAN := V_CUSULCBRUMANT;
   VRCUSMEDLIQMAN := V_CUSMEDLIQMANT;
   VRCUSMEDBRUMAN := V_CUSMEDBRUMANT;
END;
/
